
#ifndef KWINUTILS_H
#define KWINUTILS_H

#include <QObject>
#include <QVariant>
#include <QDBusAbstractAdaptor>

class KWinUtils;

class KwinAdaptor : public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "com.kde.KWin")
    Q_CLASSINFO("D-Bus Introspection", ""
"  <interface name=\"com.kde.KWin\">\n"
"    <method name=\"CreateDesktop\"/>\n"
"    <method name=\"removeDesktop\">\n"
"      <arg direction=\"in\" type=\"i\"/>\n"
"    </method>\n"
"    <method name=\"GetDesktopNumber\">\n"
"      <arg direction=\"out\" type=\"i\"/>\n"
"    </method>\n"
"    <method name=\"removeWindow\">\n"
"      <arg direction=\"in\" type=\"s\"/>\n"
"    </method>\n"
"  </interface>\n"
        "")
public:
    KwinAdaptor(QObject *parent);
    virtual ~KwinAdaptor();

public: // PROPERTIES
public Q_SLOTS: // METHODS
    void CreateDesktop();
    void removeDesktop(int);
    int GetDesktopNumber();
    void removeWindow(QString);
Q_SIGNALS: // SIGNALS
};


class KWinUtils : public QObject
{
    Q_OBJECT
public:

    explicit KWinUtils(QObject *parent = nullptr);
    ~KWinUtils();

public Q_SLOTS:
    void CreateDesktop();
    void removeDesktop(int);
    int GetDesktopNumber();
    void removeWindow(ulong);
};

#endif // KWINUTILS_H
